"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _filterDomProps = require("./lib/filter-dom-props");

var _filterDomProps2 = _interopRequireDefault(_filterDomProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactImageFallback = (function (_Component) {
	_inherits(ReactImageFallback, _Component);

	function ReactImageFallback(props) {
		_classCallCheck(this, ReactImageFallback);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReactImageFallback).call(this, props));

		_this.displayImage = new window.Image();
		_this.state = {
			imageSource: props.initialImage
		};
		_this.setDisplayImage = _this.setDisplayImage.bind(_this);
		return _this;
	}

	_createClass(ReactImageFallback, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.setDisplayImage(this.props.src, this.props.fallbackImage);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(nextProps) {
			if (nextProps.src !== this.props.src) {
				this.setDisplayImage(nextProps.src, nextProps.fallbackImage);
			}
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.displayImage.onerror = null;
			this.displayImage.onload = null;
		}
	}, {
		key: "setDisplayImage",
		value: function setDisplayImage(image, fallback) {
			var _this2 = this;

			this.displayImage.onerror = function () {
				_this2.setState({
					imageSource: fallback
				}, function () {
					if (_this2.props.onError) {
						_this2.props.onError(image);
					}
				});
			};
			this.displayImage.onload = function () {
				_this2.setState({
					imageSource: image
				}, function () {
					if (_this2.props.onLoad) {
						_this2.props.onLoad(image);
					}
				});
			};
			this.displayImage.src = image;
		}
	}, {
		key: "render",
		value: function render() {
			var domProps = (0, _filterDomProps2.default)(this.props);
			return this.state.imageSource ? _react2.default.createElement("img", _extends({}, domProps, { src: this.state.imageSource })) : null;
		}
	}]);

	return ReactImageFallback;
})(_react.Component);

exports.default = ReactImageFallback;

ReactImageFallback.displayName = "ReactImageFallback";

ReactImageFallback.propTypes = {
	src: _react.PropTypes.string.isRequired,
	fallbackImage: _react.PropTypes.string.isRequired,
	initialImage: _react.PropTypes.string,
	onLoad: _react.PropTypes.func,
	onError: _react.PropTypes.func
};

ReactImageFallback.defaultProps = {
	initialImage: null
};